const MPData = require('./MPData.js');
const http = require('http');
const fs = require('fs');
const url = require('url');
const port = 8082;


const requestListener = function (req, res) {
	if(req.method == 'GET'){
		const queryObject = url.parse(req.url,true).query; 
		if( req.url.indexOf('getlevel') > -1){
console.log("Level: ", queryObject.level);
			var retval=getLevel(queryObject.level);
res.setHeader('Access-Control-Allow-Origin', '*');
			res.writeHead(200);
			res.end(retval);
		}
		if( req.url.indexOf('setlevel') > -1){
			var level=queryObject.level;
			var data=queryObject.data;
console.log("Level: ", level);
			writeLevel(level,data);
		}
		// MultiPlayer Data
		if( req.url.indexOf('mpdata') > -1){
			var retval='';
			retval=MPData.MPDataCall(queryObject);
			res.writeHead(200);
			res.end(retval);
			
		}

	}else{
res.setHeader('Access-Control-Allow-Origin', '*');
		res.writeHead(200);
		res.end('character levels \nuse : getlevel?level=1\n');

	}
}

const server = http.createServer(requestListener);
server.listen(port);
console.log('Server running on port '+port);



function getLevel(level){

	var retval='';
		// Check 
	var file='levels/'+level+'.txt';
console.log("testing file: ", file);
	try {
		if (fs.existsSync(file)) {
			try {
console.log("opening file: ", file);
				retval = fs.readFileSync(file, 'utf8');
			} catch (err) {
console.log("openfile err: ", err);
				retval = getRandom();
			}
  		}else{
			retval = getRandom();
		}
	} catch(err) {
console.log("exist file err: ", err);
		retval = getRandom();
	}
	return retval;
}

function getRandom(){
console.log("Random called");
	var retval='GRIDSIZE=32,';
	var isPlayer=false;
	
	for(let i=0; i < 32*32; i++){
		var o=Math.floor(Math.random()*6);
		if(Math.random()*10 > 8 && !isPlayer){
			isPlayer=true;
			retval+=''+i+'=1000,';
		}else{
			if(o > 0)retval+=''+i+'='+o+',';
		}
	}
	return retval;
}

function writeLevel(level,data){
	var file='levels/'+level+'.txt';

	try {
		fs.writeFileSync(file, data);
	} catch (err) {
		console.error("writeLevel "+level+" = error ", err);
	}
}

